----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    09:45:59 05/01/2009 
-- Design Name: 
-- Module Name:    Controller - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Controller is
    Port ( Start : in  STD_LOGIC;
           Stop : in  STD_LOGIC;
           Inc : in  STD_LOGIC;
           Clk : in  STD_LOGIC;
           RST : in  STD_LOGIC;
           Run : out  STD_LOGIC);
end Controller;
architecture Behavioral of Controller is


type Controller_statetype is ( stStopped, stRunning, stIncrem, stTrap);

signal  stNext : Controller_statetype;

signal stPres : Controller_statetype:= stStopped;

begin


	process (CLK, RST) begin
		if RST = '1' then
			stPres<=stStopped;
		elsif rising_edge(CLK) then
			stPres<=stNext;
		end if;
	end process;
	
	process (stPres, start, inc, stop)
	begin
		case stPres is
			when stStopped =>
				Run <= '0';
				if start = '1' then
					stNext<=stRunning;
				elsif inc = '1' then
					stNext<=stIncrem;
				else
					stNext<=stStopped;
				end if;
			
			when stRunning =>
				Run<='1';
				if stop = '1' then
					stNext <= stStopped;
				else
					stNext <= stRunning;
				end if;
			
			when stIncrem =>
				Run<='1';
				stNext<=stTrap;
			
			when stTrap=>
				Run<='0';
				if inc = '0' then
					stNext<=stStopped;
				else
					stNext<=stTrap;
				end if;
			
			when others =>
				Run<='0';
				stNext<=stStopped;
		end case;
	end process;	
		--		if (RST = '1') then
--			ContrState <= stopped;
--			elsif rising_edge(CLK) then
--				if start = '1' then
--					ContrState <= running;
--				elsif inc = '1' then 
--					ContrState <= increm;
--				end if;
--		
--			elsif ContrState = running then
--				if stop = '1' then
--					ContrState <= stopped;
--				end if;
--		
--		elsif ContrState = increm then
--			ContrState <= trap;
--			
--		elsif ContrState = trap then
--			if inc = '0' then 
--				ContrState <= stopped;
--			end if;
--		end if;
end Behavioral;

