----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    09:44:47 05/01/2009 
-- Design Name: 
-- Module Name:    mainIncrementer - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity mainIncrementer is
    Port ( Start : in  STD_LOGIC;
           Stop : in  STD_LOGIC;
           Inc : in  STD_LOGIC;
           RST : in  STD_LOGIC;
			   anos:	out std_logic_vector (3 downto 0);
				ssd : out  STD_LOGIC_vector (6 downto 0);
				CLK : in std_logic;
				LED0,LED1,LED2,LED3 :out std_logic
				);
end mainIncrementer;


architecture Behavioral of mainIncrementer is


component Controller
Port ( Start : in  STD_LOGIC;
           Stop : in  STD_LOGIC;
           Inc : in  STD_LOGIC;
           Clk : in  STD_LOGIC;
           RST : in  STD_LOGIC;
           Run : out  STD_LOGIC);
end component;


component Clk_div
Port ( CLK : in  STD_LOGIC;
           RST : in  STD_LOGIC;
           Clkout : out  STD_LOGIC);
end component;


component ssdDecoder
Port ( 	bin : in  STD_LOGIC_vector (3 downto 0);
			ssd : out  STD_LOGIC_vector (6 downto 0));

end component;

component FourBitCounter
 Port ( CEN : in  STD_LOGIC;
           CLK : in  STD_LOGIC;
           RST : in  STD_LOGIC;
           B : out  STD_LOGIC_VECTOR (3 downto 0);
           TC : out  STD_LOGIC);
end component;

component mux16_4
 Port ( anos : in  STD_LOGIC_VECTOR (1 downto 0);
           a : in  STD_LOGIC_VECTOR (3 downto 0);
           disp : out  STD_LOGIC_VECTOR (3 downto 0);
           b : in  STD_LOGIC_VECTOR (3 downto 0);
           c : in  STD_LOGIC_VECTOR (3 downto 0);
           d : in  STD_LOGIC_VECTOR (3 downto 0));
end component;

component anodeSeq
			port ( CLK : in  STD_LOGIC;
           RST : in  STD_LOGIC;
           ano : out  STD_LOGIC_VECTOR (1 downto 0));
			  end component;

signal clkpass: std_logic;
signal runpass: std_logic;
signal apass: std_logic_vector (3 downto 0);
signal bpass: std_logic_vector (3 downto 0); 
signal cpass: std_logic_vector (3 downto 0);
signal dpass: std_logic_vector (3 downto 0);
signal anopass: std_logic_vector (1 downto 0);
signal dispass: std_logic_vector (3 downto 0);
signal tca : STD_LOGIC;
signal tcb : STD_LOGIC;
signal tcc : STD_LOGIC;
signal lala: std_logic;

begin

C0: Clk_div port map (CLK => CLK, RST => RST, Clkout=> clkpass);
C1: Controller port map (Start=> Start, Stop => Stop, Inc => Inc, Clk => Clkpass, RST => RST, Run => runpass);
C2: FourBitCounter port map (CEN => runpass, CLK => Clkpass, RST => RST, B => apass,  TC => tca	);
C3: FourBitCounter port map (CEN => runpass, CLK => tca, RST => RST, B => bpass, TC => tcb	);
C4: FourBitCounter port map (CEN => runpass, CLK => tcb, RST => RST, B=> cpass, TC => tcc );
C5: FourBitCounter port map (CEN => runpass, CLK => tcc, RST => RST, B=> dpass, TC => lala	);
C6: anodeSeq port map (CLK => CLK, RST => RST, ano => anopass );
C7: mux16_4 port map (anos => anopass, a => apass, b => bpass, c => cpass, d => dpass, disp => dispass 	);
C8: ssdDecoder port map (bin => dispass, ssd => ssd);

with anopass select
	anos <=  "0111" when "00",
				"1011" when "01",
				"1101" when "10",
				"1110" when others;

LED0 <= tca;
LED1 <= tcb;
LED2 <= tcc;
LED3 <= lala;


end Behavioral;

